<?php
if(!function_exists('sql_table')){
	function sql_table($name) {
		return 'nucleus_' . $name;
	}
}
class NP_View extends NucleusPlugin {
	function getName() { return 'View'; }
	function getAuthor() { return 'jun'; }
	function getURL() { return 'http://japan.nucleuscms.org/bb/viewtopic.php?t=709'; }
	function getVersion() { return '1.121'; }
	function getDescription() { return 'This plugin displays the most viewed items by dairy, weekly, monthly, yearly. Special thanks for Rodrigo Moraes (*NP_Views) and Edmond Hui (*NP_MostViewed). http://www.tipos.com.br/'; }
	function supportsFeature($what) {
		switch($what){
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}
	function install() {
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_view').' (id int(11) unsigned not null, view int(11) unsigned, ip char(11), vtime datetime not null, week0 mediumint(8) unsigned not null, week1 mediumint(8) unsigned not null, week2 mediumint(8) unsigned not null, week3 mediumint(8) unsigned not null, week4 mediumint(8) unsigned not null, week5 mediumint(8) unsigned not null, week6 mediumint(8) unsigned not null, month01 int(11) unsigned not null, month02 int(11) unsigned not null, month03 int(11) unsigned not null, month04 int(11) unsigned not null, month05 int(11) unsigned not null, month06 int(11) unsigned not null, month07 int(11) unsigned not null, month08 int(11) unsigned not null, month09 int(11) unsigned not null, month10 int(11) unsigned not null, month11 int(11) unsigned not null, month12 int(11) unsigned not null, PRIMARY KEY (id))');
		$this -> createOption('loggedin', '1. Count at loggedin?', 'yesno', 'no');
		$this -> createOption('ip_count', '2. Count at same IPadress?', 'yesno', 'no');
		$this -> createOption('del_item', '3. Delete View Counts on deleted item?', 'yesno', 'yes');
		$this -> createOption('del_uninstall', '4. Delete tables on uninstall?', 'yesno', 'no');
		$this -> createOption('item_except', '5. ItemID to except. (*ex. 3/15/120)','text','');
		$this -> createOption('cat_except', '6. CategoryID to except. (*ex. 2/5/8)','text','');
		$this -> createOption('blog_except', '7. BlogID to except. (*ex. 1/4)','text','');
		$this -> createOption('month_format','8. Last month format. (*ex. Y-m )','text','Y-m');
		$this -> createOption('day_format','9. Last day format. (*ex. Y-m-d )','text','Y-m-d');
		$this -> createOption('week_format','10. Week or Year format. (*ex. -> )','text',' -> ');
		$this -> createOption('box_format','11. Viewbody\'s CSS tag. (*ex1. div)(*ex2. ol)','text','div');
		$this -> createOption('m_optimize', '12. Optimize tables every month?', 'yesno', 'no');
		$this -> createOption('d_optimize', '13. Optimize tables every day?', 'yesno', 'no');
		$this -> createOption('s_format', '14. Switch format. (*ex. <br />[switch]:)', 'text', '<br />[switch]:');
		$this -> createOption('s_main', '15. Switch button. (*ex. Daily/Weekly/Monthly/Yearly/ Access Ranking)', 'text', 'Daily/Weekly/Monthly/Yearly/ Access Ranking');
	}
	function unInstall() {
		if($this -> getOption('del_uninstall') == 'yes') {
			mysql_query("DROP table ".sql_table('plugin_view'));
		}
		$this -> deleteOption('loggedin');
		$this -> deleteOption('ip_count');
		$this -> deleteOption('del_item');
		$this -> deleteOption('del_uninstall');
		$this -> deleteOption('item_except');
		$this -> deleteOption('cat_except');
		$this -> deleteOption('blog_except');
		$this -> deleteOption('month_format');
		$this -> deleteOption('day_format');
		$this -> deleteOption('week_format');
		$this -> deleteOption('box_format');
		$this -> deleteOption('m_optimize');
		$this -> deleteOption('d_optimize');
		$this -> deleteOption('s_format');
		$this -> deleteOption('s_main');
	}
	function getTableList() {
		return array(sql_table('plugin_view'));
	}
	function getEventList() {
		return array('PostDeleteItem');
	}
	function event_PostDeleteItem($data) {
		global $itemid;
		if($this -> getOption('del_item') == 'no') return;
		sql_query('DELETE FROM '.sql_table('plugin_view')." WHERE id = ".$itemid);
		return;
	}
	function doTemplateVar(&$item, $what = '', $num = '') {
    $itemid = intval($item -> itemid);
		$num = explode('/', $num);
		$num[0] = ($_GET['vnum']) ? intval($_GET['vnum']) : intval($num[0]);
		$vtime = date("Y-m-d H:i:s");
		sscanf($vtime, '%d-%d-%d', $y, $m, $d);
		if($what == 'day') {
			$t0 = mktime(0, 0, 0, $m, $d-$num[0], $y);
		}elseif($what == 'month') {
			$t0 = mktime(0, 0, 0, $m-$num[0], $d, $y);
		}else {
			$t0 = mktime(0, 0, 0, $m, $d, $y);
		}
		$t0m = date("m", $t0);
		$vday = 'week'.strftime("%w", $t0);
		$vmonth = 'month'.$t0m;
		$q1 = sql_query('SELECT view, '.$vday.' as vday, week0+week1+week2+week3+week4+week5+week6 as vweek, '.$vmonth.' as vmonth, month01+month02+month03+month04+month05+month06+month07+month08+month09+month10+month11+month12 as vyear, vtime, ip FROM '.sql_table('plugin_view').' WHERE id = '.$itemid);
		while($row = mysql_fetch_assoc($q1)) {
			if(!$what || $what == 'view') $view = $row['view'];
			if($what == 'day' && ($num[1] != 'get' || $_GET['vmode'] == 'day' || (!$_GET['vmode'] && $num[2] == 'a'))) {
				if($num[1] == 'a') $view = date($this -> getOption('day_format'), $t0);
				$view .= $row['vday'];
				if($num[1] == 'num') $view = quickQuery('SELECT count('.$vday.') as result FROM '.sql_table('plugin_view').' WHERE '.$vday.' >= '.$view.' ORDER BY '.$vday);
			}
			if($what == 'week' && ($num[1] != 'get' || $_GET['vmode'] == 'week' || (!$_GET['vmode'] && $num[2] == 'a'))) $view = $row['vweek'];
			if($what == 'month' && ($num[1] != 'get' || $_GET['vmode'] == 'month' || (!$_GET['vmode'] && $num[2] == 'a'))) {
				if($num[1] == 'a') $view = date($this -> getOption('month_format'), $t0);
				$view .= $row['vmonth'];
				if($num[1] == 'num') $view = quickQuery('SELECT count('.$vmonth.') as result FROM '.sql_table('plugin_view').' WHERE '.$vmonth.' >= '.$view);
			}
			if($what == 'year' && ($num[1] != 'get' || $_GET['vmode'] == 'year' || (!$_GET['vmode'] && $num[2] == 'a')))	$view = $row['vyear'];
			if($what == 'time') $view = $row['vtime'];
			if($what == 'ip') $view = $row['ip'];
		}
		if($what == 'bname') {
			$view = quickQuery('SELECT bname as result FROM '.sql_table('blog').', '.sql_table('item').' WHERE inumber = '.$itemid.' and bnumber = iblog');
		}elseif($what == 'bid') {
			$view = quickQuery('SELECT bnumber as result FROM '.sql_table('blog').', '.sql_table('item').' WHERE inumber = '.$itemid.' and bnumber = iblog');
		}
		echo $view;
	}
	function doSkinVar($skinType, $template = 'grey/short', $vitem = '', $vmode = '', $vblog = '', $vcat = '', $num = '') {
		global $CONF, $blog, $blogid, $catid, $itemid, $member, $memberid, $MYSQL_DATABASE;
		$blogid = intval($blogid);
		$catid = intval($catid);
		$itemid = intval($itemid);
		$memberid = intval($memberid);
		$vmode = explode('/', $vmode);
		$num = explode('/', $num);
		$ip = addslashes(ServerVar('REMOTE_ADDR'));
		$vtime = date("Y-m-d H:i:s");
		if($vitem) {
			$num[0] = ($_GET['vnum']) ? intval($_GET['vnum']) : intval($num[0]);
			$vmode[0] = ($_GET['vmode']) ? htmlspecialchars($_GET['vmode']) : htmlspecialchars($vmode[0]);
		}
		sscanf($vtime, '%d-%d-%d', $y, $m, $d);
		if($vmode[0] == 'day') {
			$t0 = mktime(0, 0, 0, $m, $d-$num[0], $y);
			$tp = mktime(0, 0, 0, $m, $d-$num[0]-1, $y);
			$tn = mktime(0, 0, 0, $m, $d-$num[0]+1, $y);
		}elseif($vmode[0] == 'month') {
			$t0 = mktime(0, 0, 0, $m-$num[0], $d, $y);
			$tp = mktime(0, 0, 0, $m-$num[0]-1, $d, $y);
			$tn = mktime(0, 0, 0, $m-$num[0]+1, $d, $y);
		}else {
			$t0 = mktime(0, 0, 0, $m, $d, $y);
			$tw = mktime(0, 0, 0, $m, $d-6, $y);
			$ty = mktime(0, 0, 0, $m+1, $d, $y-1);
		}
		$t0y = date("y", $t0);
		$t0m = date("m", $t0);
		$t0d = date("d", $t0);
		$vday = 'week'.strftime("%w", $t0);
		$vmonth = 'month'.$t0m;
		if(!$vitem) {
// category display
			if($template == 'cid') {
				$view = quickQuery('SELECT icat as result FROM '.sql_table('item').' WHERE inumber = '.$itemid);
				echo $view;
			}elseif($template == 'cname') {
				$view = quickQuery('SELECT cname as result FROM '.sql_table('item').', '.sql_table('category').' WHERE inumber = '.$itemid.' and catid = icat');
				echo $view;
// count
			}elseif($member -> isLoggedIn() && $this -> getOption('loggedin') == 'no') {
				return;
			}elseif($itemid) {
				$time1 = quickQuery('SELECT vtime as result FROM '.sql_table('plugin_view').' ORDER BY vtime DESC LIMIT 1');
				sscanf($time1, '%d-%d-%d', $y, $m, $d);
				$t1 = mktime(0, 0, 0, $m, $d, $y);
				$t1y = date("y", $t1);
				$t1m = date("m", $t1);
				$t1d = date("d", $t1);
				if(!($t0y == $t1y && $t0m == $t1m && $t0d == $t1d)) {
// optimize table
					$result = mysql_list_tables($MYSQL_DATABASE);
					$i = 0;
					$qq = 'OPTIMIZE TABLE';
					while ($i < mysql_num_rows($result)) {
						$tb_names[$i] = mysql_tablename($result, $i);
						$qq .= ' `'.$tb_names[$i].'`,';
						$i++;
					}
					$number = strlen($qq);
					$qq = substr($qq, 0, $number-1);
// change field
					sql_query('ALTER TABLE '.sql_table('plugin_view').' DROP '.$vday);
					sql_query('ALTER TABLE '.sql_table('plugin_view').' ADD '.$vday.' mediumint(8) unsigned not null');
					if($this -> getOption('d_optimize') == 'yes') $qp = sql_query($qq);
					if($t0m != $t1m) {
						sql_query('ALTER TABLE '.sql_table('plugin_view').' DROP '.$vmonth);
						sql_query('ALTER TABLE '.sql_table('plugin_view').' ADD '.$vmonth.' int(15) unsigned not null');
						if($this -> getOption('m_optimize') == 'yes' && !$qp) sql_query($qq);
					}
				}
// countup
				$res = mysql_query('SELECT view, ip, '.$vday.', '.$vmonth.' FROM '.sql_table('plugin_view').' WHERE id = '.$itemid);
				$row = mysql_fetch_object($res);
	 			$view = intval($row -> view);
	 			$wview = intval($row -> $vday);
	 			$mview = intval($row -> $vmonth);
				if(mysql_num_rows($res) == 0) {
					sql_query('INSERT INTO '.sql_table('plugin_view')." (id, view, $vday, $vmonth, ip, vtime) VALUES ('$itemid', '1', '1', '1', '$ip', '$vtime')");
				}elseif(!($ip == $row -> ip && $this -> getOption('ip_count') == 'no')) {
					$view++;
					$wview++;
					$mview++;
				  sql_query("UPDATE ".sql_table('plugin_view')." SET view = '$view', $vday = '$wview', $vmonth = '$mview', ip = '$ip', vtime = '$vtime' WHERE id = $itemid");
				}
			}
// display
		}else {
			$date_f = ($vmode[0] == 'day' || $vmode[0] == 'week' || $_GET['vmode'] == 'day' || $_GET['vmode'] == 'week') ? $this -> getOption('day_format') : $this -> getOption('month_format');
			$query = 'SELECT DISTINCT i.ititle as title, i.iblog as blog, i.inumber as itemid, i.ibody as body, i.imore as more, UNIX_TIMESTAMP(i.itime) as timestamp, i.itime, c.cname as category, c.catid as catid, m.mname as author, m.mrealname as authorname, m.mnumber as authorid, week0+week1+week2+week3+week4+week5+week6 as vweek, month01+month02+month03+month04+month05+month06+month07+month08+month09+month10+month11+month12 as vyear FROM '.sql_table('item').' as i, '.sql_table('blog').' as b, '.sql_table('category').' as c, '.sql_table('member').' as m, '.sql_table('plugin_view').' as v WHERE v.id = i.inumber and c.catid = i.icat and b.bnumber = c.cblog and i.iauthor = m.mnumber';
			$ihide = explode('/', $this -> getOption('item_except'));
			$chide = explode('/', $this -> getOption('cat_except'));
			$bhide = explode('/', $this -> getOption('blog_except'));
// item
			if($ihide[0]) foreach($ihide as $ihides){
				$query .= ' and i.inumber != '.$ihides;
			}
// category
			if($chide[0]) foreach($chide as $chides){
				$query .= ' and i.icat != '.$chides;
			}
			if($vcat && $vcat != 'b') {
				$vcat = implode(', ', $vcat);
				$query .= ' and i.icat in ('.$vcat.')';
			}
// blog
			if($vblog == 'all') {
				if($bhide[0]) foreach($bhide as $bhides){
					$query .= ' and i.iblog != '.$bhides;
				}
			}elseif($vblog == '' || $vblog == 0) {
				if($vcat == 'b') {
					$query .= ' and i.iblog = '.$blogid;
				}else {
					$query .= (!$catid) ? ' and i.iblog = '.$blogid : ' and i.icat = '.$catid;
				}
			}else {
				$vblog = str_replace('/', ', ', $vblog);
				$query .= ' and i.iblog in ('.$vblog.')';
			}
// mode
			if($vmode[0] == 'm') {
				$memid = $member -> getID();
				$query .= ' and i.iauthor = '.$memid;
			}elseif($vmode[0] == 'mem') {
				$query .= ($vmode[1]) ? ' and i.iauthor = '.$vmode[1] : ' and i.iauthor = '.$memberid;
			}elseif($vmode[0] == 'time') {
				$query .= ' ORDER BY v.vtime';
			}elseif($vmode[0] == 'day') {
				$query .= ' ORDER BY '.$vday;
			}elseif($vmode[0] == 'week') {
				$query .= ' ORDER BY vweek';
			}elseif($vmode[0] == 'month') {
				$query .= ' ORDER BY '.$vmonth;
			}elseif($vmode[0] == 'year') {
				$query .= ' ORDER BY vyear';
			}else {
				$query .= ' ORDER BY v.view';
			}
			$vitem = ($vitem > 100) ? 100 : $vitem;
			$query .= ' DESC, vweek DESC LIMIT '.$vitem;
//print
			if($num[1]) echo '<div class="viewtitle">';
			$uri = sprintf('%s%s%s', 'http://', $_SERVER['HTTP_HOST'], $_SERVER['REQUEST_URI']);
			$vl = explode('&', $uri);
			$vlink = ($CONF['URLMode'] == 'pathinfo') ? '<a href="'.$_SERVER['PHP_SELF'].'?vmode=' : '<a href="'.htmlspecialchars($vl[0]).'&amp;vmode=';			
			$j0 = ($_GET['vmode'] == 'day') ? 'week'.strftime("%w", $tp) : 'month'.strftime("%m", $tp);
			$j1 = quickQuery('SELECT SUM('.$j0.') as result FROM '.sql_table('plugin_view').' GROUP BY id');
			if($num[1] == 'b' && $_GET['vmode'] != 'week' && $_GET['vmode'] != 'year' && $j1) echo $vlink.$vmode[0].'&amp;vnum='.($num[0]+1).'">'.date($date_f, $tp).'</a> &laquo; ';
			if($vmode[0] == 'day' && $num[1]) echo date($date_f, $t0);
			if($vmode[0] == 'week' && $num[1]) echo date($date_f, $tw).$this -> getOption('week_format').date($date_f, $t0);
			if($vmode[0] == 'month' && $num[1]) echo date($date_f, $t0);
			if($vmode[0] == 'year' && $num[1]) echo date($date_f, $ty).$this -> getOption('week_format').date($date_f, $t0);
			if($num[1] == 'b' && $num[0] > 0 && $_GET['vmode'] != 'week' && $_GET['vmode'] != 'year') echo ' &raquo; '.$vlink.$vmode[0].'&amp;vnum='.($num[0]-1).'">'.date($date_f, $tn).'</a>';
			if($num[1] == 'b') {
				$s_main = explode('/', $this -> getOption('s_main'));
				echo $this -> getOption('s_format');
				if($s_main[0]) echo $vlink.'day" title="'.$s_main[0].$s_main[4].'">'.$s_main[0].'</a> ';
				if($s_main[1]) echo $vlink.'week" title="'.$s_main[1].$s_main[4].'">'.$s_main[1].'</a> ';
				if($s_main[2]) echo $vlink.'month" title="'.$s_main[2].$s_main[4].'">'.$s_main[2].'</a> ';
				if($s_main[3]) echo $vlink.'year" title="'.$s_main[3].$s_main[4].'">'.$s_main[3].'</a>';
			}
			if($num[1]) echo '</div>';
			echo '<'.$this -> getOption('box_format').' class="viewbody">';
			$blog -> showUsingQuery($template, $query, 1, 1, 1);
			echo '</'.$this -> getOption('box_format').'>';
		}
	}
}
?>